use strict;
use warnings;
# SA
#parameter file parsing
#Tue Aug 30 10:12:41 2016

sub conf_read{
    my ($file)=@_;
    open(CONFIG,"$file") or die "Cannot open \"$file\"\n";
    my %params;
    while (<CONFIG>)
    {
        chomp $_;
        if (($_=~m/^#/) || ($_=~m/^\s+$/)||($_ eq "") || (!defined$_))
        {
            next;
        }
        else
        {
            my @arr=split/=/,$_;
	    chomp $arr[1];
            $params{$arr[0]}=$arr[1];
        }   
    }
    close CONFIG;
    return (\%params);
    
}
sub check_params{
    my ($par,$pref,$href)=@_;
    my %params=%$par;
    my %plex=%$pref;
    my %header=%$href;
    my @err_msg;
    
    if (!defined $params{Spectra_Folder})##TODO Directory IO flag
    {
	$params{Spectra_Folder}='Input';##this is the default folder to input data
	#push(@err_msg,"Spectra folder set to default \"Input\" folder");
    }
    if (!(-d $params{Spectra_Folder}))
    {
	#die "\"$params{Spectra_Folder}\" is not a directory\n";
	push(@err_msg,"\"$params{Spectra_Folder}\" is not a directory");
    }
    
    if(!defined $params{min_reporters})#TODO between 1 and maxplex check
    {
	$params{min_reporters}=2; #default
	#push(@err_msg,"Minimum reporters for a spectrum to get quantitated is not defined. Set to default(2)");
    }
    if (!defined $params{Spectrum_area})
    {
	$params{Spectrum_area}='B';##making default as baseline line corrected area
	#push(@err_msg,"Spectrum area not defined. Set to default Sum intensity based baseline corrected method.");
    }
    
    if ($params{Label_type} eq "iTRAQ") #check Base reporter for specific plex and rep type
    {
	my $flag=0;#base reporter not among the reporters
	if (!($params{Plex} eq "8plex" || $params{Plex} eq "4plex"))
	{
	    #print "iTRAQ cannot be $params{Plex}\n";
	    #exit;
	    push(@err_msg,"iTRAQ cannot be $params{Plex}");
	}
	else
	{
	    for(my $i=0;$i<@{$header{$params{Label_type}}{$params{Plex}}};$i++)
	    {
	        my $tag=$header{$params{Label_type}}{$params{Plex}}[$i];
	        #print "base reporter is : $tag";<>;
	        if ($params{Base_reporter} eq $tag)
	        {
		    $flag=1;
		    $params{Base_reporter}=$plex{$params{Label_type}}{$params{Plex}}[$i];
		}
	    }
	    if ($flag==0)#base reporter either not defined or not correctly defined, choose first reporter
	    {
	        print "Base reporter ion tag provided does not exist for $params{Label_type}\n";
	        $params{Base_reporter}=$plex{$params{Label_type}}{$params{Plex}}[0];      
	    }
	}
    }
    elsif($params{Label_type} eq "TMT")
    {
	my $flag=0;
	if (!($params{Plex} eq "6plex" || $params{Plex} eq "2plex" || $params{Plex} eq "10plex"))
	{
	    push(@err_msg,"TMT cannot be $params{Plex}");
	}
	else
	{
	    for(my $i=0;$i<@{$header{$params{Label_type}}{$params{Plex}}};$i++)
	    {
		my $tag=$header{$params{Label_type}}{$params{Plex}}[$i];#TODO check here
		if ($params{Base_reporter} eq $tag)
		{
		    $flag=1;
		    $params{Base_reporter}=$plex{$params{Label_type}}{$params{Plex}}[$i];
		}
	    }
	    if ($flag==0)#base reporter either not defined or not correctly defined, choose first reporter
	    {
		print "Base reporter ion tag provided does not exist for $params{Label_type}\n";
		$params{Base_reporter}=$plex{$params{Label_type}}{$params{Plex}}[0];
	    }
	}
    }
    else
    {
	push(@err_msg,"$params{Label_type} is not the correct Reporter ion method");
    }
    if ($params{Tol_unit} ne "Da" && $params{Tol_unit} ne "ppm")
    {
	print "Tolerance unit defined incorrectly. Da will be choosen as the Tolerance unit\n";
	$params{Tol_unit}="Da";
    }
    
    if (!defined $params{Purity_corrections_values}) #default purity correction applied when not defined by user
    {
	$params{Purity_corrections_values}=$params{Label_type}.$params{Plex}.".tsv";
    }
    if ($params{Input_file_extension} ne "mgf" && $params{Input_file_extension} ne "mzML")
    {
        push(@err_msg,"The input \"$params{Input_file_extension}\" format is not supported. Try mzML or mgf");
    }
    return(\%params,\@err_msg);
}
1;